Index: SRUAggregator/trunk/build.sh
===================================================================
--- SRUAggregator/trunk/build.sh	(revision 5971)
+++ SRUAggregator/trunk/build.sh	(revision 5976)
@@ -13,5 +13,5 @@
 
 	npm install bower react-tools
-	node_modules/bower/bin/bower install jquery bootstrap react react-addons react-router font-awesome
+	node_modules/bower/bin/bower install jquery bootstrap react react-addons font-awesome
 
 	cp bower_components/bootstrap/dist/css/bootstrap.min.css $LIBDIR/
@@ -21,5 +21,4 @@
 	cp bower_components/react/react-with-addons.js $LIBDIR/
 	cp bower_components/react/react-with-addons.min.js $LIBDIR/
-	cp bower_components/react-router/dist/react-router.min.js $LIBDIR/
 	cp bower_components/font-awesome/css/font-awesome.min.css $LIBDIR/
 
Index: SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/app/Aggregator.java
===================================================================
--- SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/app/Aggregator.java	(revision 5971)
+++ SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/app/Aggregator.java	(revision 5976)
@@ -88,13 +88,4 @@
  * @author edima
  *
- * TODO: Send mail to Dieter with centers that do not accept recordSchema
- * parameter
- *
- * TODO: mail to LINDAT-Clarin devel about matching whole word in search
- *
- * TODO: routing
- *
- * TODO: stats page as tabs
- *
  * TODO: Download search results as csv, excel, tcf, plain text
  *
@@ -157,6 +148,7 @@
 	@Override
 	public void initialize(Bootstrap<AggregatorConfiguration> bootstrap) {
-		bootstrap.addBundle(new AssetsBundle("/assets", "/", "index.html"));
-	}
+		bootstrap.addBundle(new AssetsBundle("/assets", "/", "index.html", "static"));
+	}
+
 
 	@Override
@@ -172,4 +164,5 @@
 		}
 
+		environment.getApplicationContext().setErrorHandler(new ErrorPageHandler());
 		environment.jersey().setUrlPattern("/rest/*");
 		environment.jersey().register(new RestService());
Index: SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/app/ErrorPageHandler.java
===================================================================
--- SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/app/ErrorPageHandler.java	(revision 5976)
+++ SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/app/ErrorPageHandler.java	(revision 5976)
@@ -0,0 +1,42 @@
+package eu.clarin.sru.fcs.aggregator.app;
+
+import java.util.ArrayList;
+import java.util.List;
+import javax.servlet.http.HttpServletRequest;
+import javax.ws.rs.ext.Provider;
+import org.eclipse.jetty.servlet.ErrorPageErrorHandler;
+
+/**
+ *
+ * @author edima
+ */
+@Provider
+public class ErrorPageHandler extends ErrorPageErrorHandler {
+
+	List<String> staticRoutes;
+
+	public ErrorPageHandler() {
+		staticRoutes = new ArrayList<String>();
+		staticRoutes.add("/rest");
+		staticRoutes.add("/admin");
+		staticRoutes.add("/lib");
+		staticRoutes.add("/js");
+		staticRoutes.add("/fonts");
+		staticRoutes.add("/img");
+	}
+
+	static boolean prefix(String url, String prefix) {
+		return url.equals(prefix) || url.startsWith(prefix + "/") || url.startsWith(prefix + "?");
+	}
+
+	@Override
+	public String getErrorPage(HttpServletRequest request) {
+		String url = request.getPathInfo();
+		for (String pre : staticRoutes) {
+			if (prefix(url, pre)) {
+				return null;
+			}
+		}
+		return "/index.html";
+	}
+}
Index: SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/rest/RestService.java
===================================================================
--- SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/rest/RestService.java	(revision 5971)
+++ SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/rest/RestService.java	(revision 5976)
@@ -75,17 +75,19 @@
 		Object j = new HashMap<String, Object>() {
 			{
-				put("lastScanStats", new HashMap<String, Object>() {
+				put("Last Scan", new HashMap<String, Object>() {
 					{
 						put("maxConcurrentScanRequestsPerEndpoint",
 								Aggregator.getInstance().getParams().getSCAN_MAX_CONCURRENT_REQUESTS_PER_ENDPOINT());
 						put("timeout", params.getENDPOINTS_SCAN_TIMEOUT_MS() / 1000.);
+						put("isScan", true);
 						put("institutions", scan.getInstitutions());
 					}
 				});
-				put("searchStats", new HashMap<String, Object>() {
+				put("Recent Searches", new HashMap<String, Object>() {
 					{
 						put("maxConcurrentSearchRequestsPerEndpoint",
 								Aggregator.getInstance().getParams().getSEARCH_MAX_CONCURRENT_REQUESTS_PER_ENDPOINT());
 						put("timeout", params.getENDPOINTS_SEARCH_TIMEOUT_MS() / 1000.);
+						put("isScan", false);
 						put("institutions", search.getInstitutions());
 					}
Index: SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/scan/ScanCrawler.java
===================================================================
--- SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/scan/ScanCrawler.java	(revision 5971)
+++ SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/scan/ScanCrawler.java	(revision 5976)
@@ -270,5 +270,7 @@
 							if (corpora.addCorpus(c, parentCorpus)) {
 								new ScanTask(institution, endpoint, c, corpora, depth + 1).start();
-								statistics.addEndpointCollection(institution, endpoint, c.getTitle());
+								if (parentCorpus == null) {
+									statistics.addEndpointCollection(institution, endpoint, c.getTitle());
+								}
 							}
 						}
Index: SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/search/Search.java
===================================================================
--- SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/search/Search.java	(revision 5971)
+++ SRUAggregator/trunk/src/main/java/eu/clarin/sru/fcs/aggregator/search/Search.java	(revision 5976)
@@ -6,4 +6,5 @@
 import eu.clarin.sru.client.SRUSearchRetrieveRequest;
 import eu.clarin.sru.client.SRUSearchRetrieveResponse;
+import eu.clarin.sru.client.fcs.ClarinFCSRecordData;
 import eu.clarin.sru.fcs.aggregator.client.ThrottledClient;
 import eu.clarin.sru.fcs.aggregator.scan.Corpus;
@@ -63,16 +64,14 @@
 		searchRequest.setVersion(version);
 		searchRequest.setMaximumRecords(maxRecords);
-		FCSProtocolVersion fcsVersion = corpus.getEndpoint().getProtocol();
-//		searchRequest.setRecordSchema(
-//				fcsVersion.equals(FCSProtocolVersion.LEGACY)
-//						? ClarinFCSRecordData.LEGACY_RECORD_SCHEMA
-//						: ClarinFCSRecordData.RECORD_SCHEMA);
+		boolean legacy = corpus.getEndpoint().getProtocol().equals(FCSProtocolVersion.LEGACY);
+		searchRequest.setRecordSchema(legacy
+				? ClarinFCSRecordData.LEGACY_RECORD_SCHEMA
+				: ClarinFCSRecordData.RECORD_SCHEMA);
 		searchRequest.setQuery("\"" + searchString + "\"");
 		searchRequest.setStartRecord(startRecord);
 		if (corpus.getHandle() != null) {
-			searchRequest.setExtraRequestData(
-					fcsVersion.equals(FCSProtocolVersion.LEGACY)
-							? SRUCQL.SEARCH_CORPUS_HANDLE_LEGACY_PARAMETER
-							: SRUCQL.SEARCH_CORPUS_HANDLE_PARAMETER,
+			searchRequest.setExtraRequestData(legacy
+					? SRUCQL.SEARCH_CORPUS_HANDLE_LEGACY_PARAMETER
+					: SRUCQL.SEARCH_CORPUS_HANDLE_PARAMETER,
 					corpus.getHandle());
 		}
Index: SRUAggregator/trunk/src/main/resources/assets/js/main.js
===================================================================
--- SRUAggregator/trunk/src/main/resources/assets/js/main.js	(revision 5971)
+++ SRUAggregator/trunk/src/main/resources/assets/js/main.js	(revision 5976)
@@ -3,5 +3,6 @@
 "use strict";
 
-var VERSION = "VERSION 2.0.0.Î±18";
+var VERSION = "VERSION 2.0.0.Î±20";
+var URLROOT = "/Aggregator-testing";
 
 var PT = React.PropTypes;
@@ -11,4 +12,8 @@
 
 var Main = React.createClass({displayName: 'Main',
+	componentWillMount: function() {
+		routeFromLocation(this);
+	},
+
 	getInitialState: function () {
 		return {
@@ -61,4 +66,8 @@
 	},
 
+	toggleCollapse: function() {
+		this.setState({navbarCollapse: !this.state.navbarCollapse});
+	},
+
 	renderAggregator: function() {
 		return React.createElement(AggregatorPage, {ajax: this.ajax, corpora: this.state.corpora, languageMap: this.state.languageMap});
@@ -70,5 +79,5 @@
 
 	renderAbout: function() {
-		return React.createElement(AboutPage, {statistics: this.statistics});
+		return React.createElement(AboutPage, null);
 	},
 
@@ -77,19 +86,28 @@
 	},
 
-	toggleCollapse: function() {
-		this.setState({navbarCollapse: !this.state.navbarCollapse});
-	},
-
-	about: function(e) {
-		this.setState({navbarPageFn: this.renderAbout});
-	},
-	statistics: function(e) {
-		this.setState({navbarPageFn: this.renderStatistics});
-	},
-
-
-	setNavbarPageFn: function(pageFn) {
-		this.setState({navbarPageFn:pageFn});
-	},
+	getPageFns: function() { 
+		return {
+			'': this.renderAggregator,
+			'help': this.renderHelp,
+			'about': this.renderAbout,
+			'stats': this.renderStatistics,
+		};
+	},
+
+	gotoPage: function(doPushHistory, pageFnName) {
+		var pageFn = this.getPageFns()[pageFnName];
+		if (this.state.navbarPageFn !== pageFn) {
+			if (doPushHistory) {
+				window.history.pushState({page:pageFnName}, '', URLROOT+"/"+pageFnName);
+			}
+			this.setState({navbarPageFn: pageFn});
+			console.log("new page: " + document.location + ", name: " + pageFnName);
+		}
+	},
+
+	toAggregator: function(doPushHistory) { this.gotoPage(doPushHistory, ''); },
+	toHelp: function(doPushHistory) { this.gotoPage(doPushHistory, 'help'); },
+	toAbout: function(doPushHistory) { this.gotoPage(doPushHistory, 'about'); },
+	toStatistics: function(doPushHistory) { this.gotoPage(doPushHistory, 'stats'); },
 
 	renderCollapsible: function() {
@@ -99,10 +117,8 @@
 				React.createElement("ul", {className: "nav navbar-nav"}, 
 					React.createElement("li", {className: this.state.navbarPageFn === this.renderAggregator ? "active":""}, 
-						React.createElement("a", {className: "link", tabIndex: "-1", 
-							onClick: this.setNavbarPageFn.bind(this, this.renderAggregator)}, "Aggregator")
+						React.createElement("a", {className: "link", tabIndex: "-1", onClick: this.toAggregator.bind(this, true)}, "Aggregator")
 					), 
 					React.createElement("li", {className: this.state.navbarPageFn === this.renderHelp ? "active":""}, 
-						React.createElement("a", {className: "link", tabIndex: "-1", 
-							onClick: this.setNavbarPageFn.bind(this, this.renderHelp)}, "Help")
+						React.createElement("a", {className: "link", tabIndex: "-1", onClick: this.toHelp.bind(this, true)}, "Help")
 					)
 				), 
@@ -154,5 +170,4 @@
 
 
-
 var StatisticsPage = React.createClass({displayName: 'StatisticsPage',
 	propTypes: {
@@ -162,6 +177,8 @@
 	getInitialState: function () {
 		return {
-			searchStats: {}, 
-			lastScanStats: {}, 
+			stats: {},
+			activeTab: 0,
+			// searchStats: {}, 
+			// lastScanStats: {}, 
 		};
 	},
@@ -175,8 +192,5 @@
 			url: 'rest/statistics',
 			success: function(json, textStatus, jqXHR) {
-				this.setState({
-					searchStats: json.searchStats, 
-					lastScanStats: json.lastScanStats, 
-				});
+				this.setState({stats: json});
 				console.log("stats:", json);
 			}.bind(this),
@@ -205,5 +219,5 @@
 							colls.length, " root collection(s):", 
 							React.createElement("ul", {className: "list-unstyled", style: {marginLeft:40}}, 
-								 colls.map(function(name) { return React.createElement("div", null, name); }) 
+								 colls.map(function(name, i) { return React.createElement("div", {key: i}, name); }) 
 							)
 						)
@@ -215,9 +229,14 @@
 		return 	React.createElement("div", {key: d.diagnostic.uri}, 
 					React.createElement("div", {className: "inline alert alert-warning"}, 
-						React.createElement("div", null, "Diagnostic: ", d.diagnostic.message, ": ", d.diagnostic.diagnostic), 
+						React.createElement("div", null, 
+							 d.counter <= 1 ? false : 
+								React.createElement("div", {className: "inline", style: {margin:"5px 5px 5px 5px"}}, 
+									React.createElement("span", {className: "badge", style: {backgroundColor:'#ae7241'}}, "x ", d.counter)
+								), 
+							
+							"Diagnostic: ", d.diagnostic.message, ": ", d.diagnostic.diagnostic
+						), 
 						React.createElement("div", null, "Context: ", React.createElement("a", {href: d.context}, d.context))
-					), 
-					" ", 
-					React.createElement("div", {className: "inline"}, React.createElement("span", {className: "badge"}, "x ", d.counter))
+					)
 				); 
 	},
@@ -227,10 +246,15 @@
 		return 	React.createElement("div", {key: xc.message}, 
 					React.createElement("div", {className: "inline alert alert-danger", role: "alert"}, 
-						React.createElement("div", null, "Exception: ", xc.message), 
+						React.createElement("div", null, 
+							 e.counter <= 1 ? false : 
+								React.createElement("div", {className: "inline", style: {margin:"5px 5px 5px 5px"}}, 
+									React.createElement("span", {className: "badge", style: {backgroundColor:'#c94442'}}, "x ", e.counter, " ")
+								), 
+							
+							"Exception: ", xc.message
+						), 
 						React.createElement("div", null, "Context: ", React.createElement("a", {href: e.context}, e.context)), 
 						 xc.cause ? React.createElement("div", null, "Caused by: ", xc.cause) : false
-					), 
-					" ", 
-					React.createElement("div", {className: "inline"}, React.createElement("span", {className: "badge"}, "x ", e.counter))
+					)
 				); 
 	},
@@ -240,5 +264,5 @@
 		var errors = _.values(stat.errors);
 		var diagnostics = _.values(stat.diagnostics);
-		return React.createElement("div", {style: {marginTop:10}}, 
+		return React.createElement("div", {style: {marginTop:10}, key: endpoint[0]}, 
 					React.createElement("ul", {className: "list-inline list-unstyled", style: {marginBottom:0}}, 
 						React.createElement("li", null, 
@@ -270,5 +294,5 @@
 
 	renderInstitution: function(isScan, inst) {
-		return 	React.createElement("div", {style: {marginBottom:30}}, 
+		return 	React.createElement("div", {style: {marginBottom:30}, key: inst[0]}, 
 					React.createElement("h4", null, inst[0]), 
 					React.createElement("div", {style: {marginLeft:20}}, " ", _.pairs(inst[1]).map(this.renderEndpoint.bind(this, isScan)) )
@@ -276,6 +300,6 @@
 	},
 
-	renderStatistics: function(isScan, stats) {
-		return 	React.createElement("div", {className: "container"}, 
+	renderStatistics: function(stats) {
+		return 	React.createElement("div", {className: "container statistics", style: {marginTop:20}}, 
 					React.createElement("ul", {className: "list-inline list-unstyled"}, 
 						 stats.maxConcurrentScanRequestsPerEndpoint ? 
@@ -291,7 +315,11 @@
 						React.createElement("li", null, "timeout:", " ", React.createElement("kbd", null, stats.timeout, " seconds"))
 					), 
-					React.createElement("div", null, " ",  _.pairs(stats.institutions).map(this.renderInstitution.bind(this, isScan)), " ")
+					React.createElement("div", null, " ",  _.pairs(stats.institutions).map(this.renderInstitution.bind(this, stats.isScan)), " ")
 				)
 				 ;
+	},
+
+	setTab: function(idx) {
+		this.setState({activeTab:idx});
 	},
 
@@ -299,10 +327,28 @@
 		return	(
 			React.createElement("div", null, 
-				React.createElement("div", {className: "top-gap statistics"}, 
+				React.createElement("div", {className: "top-gap"}, 
 					React.createElement("h1", null, "Statistics"), 
-					React.createElement("h2", null, "Last scan"), 
-					this.renderStatistics(true, this.state.lastScanStats), 
-					React.createElement("h2", null, "Searches since last scan"), 
-					this.renderStatistics(false, this.state.searchStats)
+					React.createElement("p", null), 
+					React.createElement("div", {role: "tabpanel"}, 
+						React.createElement("ul", {className: "nav nav-tabs", role: "tablist"}, 
+							 _.pairs(this.state.stats).map(function(st, idx){
+									var classname = idx === this.state.activeTab ? "active":"";
+									return 	React.createElement("li", {role: "presentation", className: classname, key: st[0]}, 
+												React.createElement("a", {href: "#", role: "tab", onClick: this.setTab.bind(this, idx)}, st[0])
+											);
+								}.bind(this))
+							
+						), 
+
+						React.createElement("div", {className: "tab-content"}, 
+							 _.pairs(this.state.stats).map(function(st, idx){
+									var classname = idx === this.state.activeTab ? "tab-pane active" : "tab-pane";
+									return 	React.createElement("div", {role: "tabpanel", className: classname, key: st[0]}, 
+												this.renderStatistics(st[1])
+											);
+								}.bind(this))
+							
+						)
+					)
 				)
 			)
@@ -358,8 +404,4 @@
 
 var AboutPage = React.createClass({displayName: 'AboutPage',
-	propTypes: {
-		statistics: PT.func.isRequired,
-	},
-
 	render: function() {
 		return	React.createElement("div", null, 
@@ -421,5 +463,5 @@
 
 						React.createElement("h3", null, "Statistics"), 
-						React.createElement("button", {type: "button", className: "btn btn-default btn-lg", onClick: this.props.statistics}, 
+						React.createElement("button", {type: "button", className: "btn btn-default btn-lg", onClick: function() {main.toStatistics(true);}}, 
 							React.createElement("span", {className: "glyphicon glyphicon-cog", 'aria-hidden': "true"}, " "), 
 							"View server log"
@@ -431,6 +473,6 @@
 
 var Footer = React.createClass({displayName: 'Footer',
-	about: function(e) {
-		main.about();
+	toAbout: function(e) {
+		main.toAbout(true);
 		e.preventDefault();
 		e.stopPropagation();
@@ -441,5 +483,5 @@
 			React.createElement("div", {className: "container"}, 
 				React.createElement("div", {id: "CLARIN_footer_left"}, 
-						React.createElement("a", {title: "about", href: "#", onClick: this.about}, 
+						React.createElement("a", {title: "about", href: "about", onClick: this.toAbout}, 
 						React.createElement("span", {className: "glyphicon glyphicon-info-sign"}), 
 						React.createElement("span", null, VERSION)
@@ -462,6 +504,54 @@
 });
 
+function endsWith(str, suffix) {
+    return str.indexOf(suffix, str.length - suffix.length) !== -1;
+}
+
+var routeFromLocation = function(com) {
+	var path = window.location.pathname.split('/');
+	if (path.length === 3) {
+		var p = path[2];
+		if (p === 'help') {
+			com.toHelp(false);
+		} else if (p === 'about') {
+			com.toAbout(false);
+		} else if (p === 'stats') {
+			com.toStatistics(false);
+		} else {
+			com.toAggregator(false);
+		}
+	} else {
+		com.toAggregator(false);
+	}
+};
+
 var main = React.render(React.createElement(Main, null),  document.getElementById('body'));
 React.render(React.createElement(Footer, null), document.getElementById('footer') );
 
+window.onpopstate = function(event) {
+	console.log("popped location: " + document.location + ", state: " + JSON.stringify(event.state));
+	routeFromLocation(main);
+};
+
+window.main = main;
+
 })();
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
Index: SRUAggregator/trunk/src/main/resources/assets/js/main.jsx
===================================================================
--- SRUAggregator/trunk/src/main/resources/assets/js/main.jsx	(revision 5971)
+++ SRUAggregator/trunk/src/main/resources/assets/js/main.jsx	(revision 5976)
@@ -3,5 +3,6 @@
 "use strict";
 
-var VERSION = "VERSION 2.0.0.Î±19";
+var VERSION = "VERSION 2.0.0.Î±20";
+var URLROOT = "/Aggregator-testing";
 
 var PT = React.PropTypes;
@@ -11,4 +12,8 @@
 
 var Main = React.createClass({
+	componentWillMount: function() {
+		routeFromLocation(this);
+	},
+
 	getInitialState: function () {
 		return {
@@ -61,4 +66,8 @@
 	},
 
+	toggleCollapse: function() {
+		this.setState({navbarCollapse: !this.state.navbarCollapse});
+	},
+
 	renderAggregator: function() {
 		return <AggregatorPage ajax={this.ajax} corpora={this.state.corpora} languageMap={this.state.languageMap} />;
@@ -70,5 +79,5 @@
 
 	renderAbout: function() {
-		return <AboutPage statistics={this.statistics}/>;
+		return <AboutPage/>;
 	},
 
@@ -77,19 +86,28 @@
 	},
 
-	toggleCollapse: function() {
-		this.setState({navbarCollapse: !this.state.navbarCollapse});
-	},
-
-	about: function(e) {
-		this.setState({navbarPageFn: this.renderAbout});
-	},
-	statistics: function(e) {
-		this.setState({navbarPageFn: this.renderStatistics});
-	},
-
-
-	setNavbarPageFn: function(pageFn) {
-		this.setState({navbarPageFn:pageFn});
-	},
+	getPageFns: function() { 
+		return {
+			'': this.renderAggregator,
+			'help': this.renderHelp,
+			'about': this.renderAbout,
+			'stats': this.renderStatistics,
+		};
+	},
+
+	gotoPage: function(doPushHistory, pageFnName) {
+		var pageFn = this.getPageFns()[pageFnName];
+		if (this.state.navbarPageFn !== pageFn) {
+			if (doPushHistory) {
+				window.history.pushState({page:pageFnName}, '', URLROOT+"/"+pageFnName);
+			}
+			this.setState({navbarPageFn: pageFn});
+			console.log("new page: " + document.location + ", name: " + pageFnName);
+		}
+	},
+
+	toAggregator: function(doPushHistory) { this.gotoPage(doPushHistory, ''); },
+	toHelp: function(doPushHistory) { this.gotoPage(doPushHistory, 'help'); },
+	toAbout: function(doPushHistory) { this.gotoPage(doPushHistory, 'about'); },
+	toStatistics: function(doPushHistory) { this.gotoPage(doPushHistory, 'stats'); },
 
 	renderCollapsible: function() {
@@ -99,10 +117,8 @@
 				<ul className="nav navbar-nav">
 					<li className={this.state.navbarPageFn === this.renderAggregator ? "active":""}>
-						<a className="link" tabIndex="-1" 
-							onClick={this.setNavbarPageFn.bind(this, this.renderAggregator)}>Aggregator</a>
+						<a className="link" tabIndex="-1" onClick={this.toAggregator.bind(this, true)}>Aggregator</a>
 					</li>
 					<li className={this.state.navbarPageFn === this.renderHelp ? "active":""}>
-						<a className="link" tabIndex="-1" 
-							onClick={this.setNavbarPageFn.bind(this, this.renderHelp)}>Help</a>
+						<a className="link" tabIndex="-1" onClick={this.toHelp.bind(this, true)}>Help</a>
 					</li>
 				</ul>
@@ -154,5 +170,4 @@
 
 
-
 var StatisticsPage = React.createClass({
 	propTypes: {
@@ -162,6 +177,8 @@
 	getInitialState: function () {
 		return {
-			searchStats: {}, 
-			lastScanStats: {}, 
+			stats: {},
+			activeTab: 0,
+			// searchStats: {}, 
+			// lastScanStats: {}, 
 		};
 	},
@@ -175,8 +192,5 @@
 			url: 'rest/statistics',
 			success: function(json, textStatus, jqXHR) {
-				this.setState({
-					searchStats: json.searchStats, 
-					lastScanStats: json.lastScanStats, 
-				});
+				this.setState({stats: json});
 				console.log("stats:", json);
 			}.bind(this),
@@ -205,5 +219,5 @@
 							{colls.length} root collection(s):
 							<ul className='list-unstyled' style={{marginLeft:40}}>
-								{ colls.map(function(name) { return <div>{name}</div>; }) }
+								{ colls.map(function(name, i) { return <div key={i}>{name}</div>; }) }
 							</ul>
 						</div>
@@ -215,9 +229,14 @@
 		return 	<div key={d.diagnostic.uri}>
 					<div className="inline alert alert-warning"> 
-						<div>Diagnostic: {d.diagnostic.message}: {d.diagnostic.diagnostic}</div>
+						<div>
+							{ d.counter <= 1 ? false : 
+								<div className="inline" style={{margin:"5px 5px 5px 5px"}}>
+									<span className="badge" style={{backgroundColor:'#ae7241'}}>x {d.counter}</span>
+								</div>
+							}
+							Diagnostic: {d.diagnostic.message}: {d.diagnostic.diagnostic}
+						</div>
 						<div>Context: <a href={d.context}>{d.context}</a></div>
 					</div>
-					{" "}
-					<div className="inline"><span className="badge">x {d.counter}</span></div>
 				</div>; 
 	},
@@ -227,10 +246,15 @@
 		return 	<div key={xc.message}>
 					<div className="inline alert alert-danger" role="alert">
-						<div>Exception: {xc.message}</div>
+						<div>
+							{ e.counter <= 1 ? false : 
+								<div className="inline" style={{margin:"5px 5px 5px 5px"}}>
+									<span className="badge" style={{backgroundColor:'#c94442'}}>x {e.counter} </span>
+								</div>
+							}
+							Exception: {xc.message}
+						</div>
 						<div>Context: <a href={e.context}>{e.context}</a></div>
 						{ xc.cause ? <div>Caused by: {xc.cause}</div> : false}
 					</div>
-					{" "}
-					<div className="inline"><span className="badge">x {e.counter}</span></div>
 				</div>; 
 	},
@@ -240,5 +264,5 @@
 		var errors = _.values(stat.errors);
 		var diagnostics = _.values(stat.diagnostics);
-		return <div style={{marginTop:10}}>
+		return <div style={{marginTop:10}} key={endpoint[0]}>
 					<ul className='list-inline list-unstyled' style={{marginBottom:0}}>
 						<li>
@@ -270,5 +294,5 @@
 
 	renderInstitution: function(isScan, inst) {
-		return 	<div style={{marginBottom:30}}>
+		return 	<div style={{marginBottom:30}} key={inst[0]}>
 					<h4>{inst[0]}</h4>
 					<div style={{marginLeft:20}}> {_.pairs(inst[1]).map(this.renderEndpoint.bind(this, isScan)) }</div>
@@ -276,6 +300,6 @@
 	},
 
-	renderStatistics: function(isScan, stats) {
-		return 	<div className="container">
+	renderStatistics: function(stats) {
+		return 	<div className="container statistics" style={{marginTop:20}}>
 					<ul className='list-inline list-unstyled'>
 						{ stats.maxConcurrentScanRequestsPerEndpoint ? 
@@ -291,7 +315,11 @@
 						<li>timeout:{" "}<kbd>{stats.timeout} seconds</kbd></li>
 					</ul>
-					<div> { _.pairs(stats.institutions).map(this.renderInstitution.bind(this, isScan)) } </div>
+					<div> { _.pairs(stats.institutions).map(this.renderInstitution.bind(this, stats.isScan)) } </div>
 				</div>
 				 ;
+	},
+
+	setTab: function(idx) {
+		this.setState({activeTab:idx});
 	},
 
@@ -299,10 +327,28 @@
 		return	(
 			<div>
-				<div className="top-gap statistics">
+				<div className="top-gap">
 					<h1>Statistics</h1>
-					<h2>Last scan</h2>
-					{this.renderStatistics(true, this.state.lastScanStats)}
-					<h2>Searches since last scan</h2>
-					{this.renderStatistics(false, this.state.searchStats)}
+					<p/>
+					<div role="tabpanel">
+						<ul className="nav nav-tabs" role="tablist">
+							{ _.pairs(this.state.stats).map(function(st, idx){
+									var classname = idx === this.state.activeTab ? "active":"";
+									return 	<li role="presentation" className={classname} key={st[0]}>
+												<a href="#" role="tab" onClick={this.setTab.bind(this, idx)}>{st[0]}</a>
+											</li>;
+								}.bind(this))
+							}
+						</ul>
+
+						<div className="tab-content">
+							{ _.pairs(this.state.stats).map(function(st, idx){
+									var classname = idx === this.state.activeTab ? "tab-pane active" : "tab-pane";
+									return 	<div role="tabpanel" className={classname} key={st[0]}>
+												{this.renderStatistics(st[1])}
+											</div>;
+								}.bind(this))
+							}
+						</div>
+					</div>
 				</div>
 			</div>
@@ -358,8 +404,4 @@
 
 var AboutPage = React.createClass({
-	propTypes: {
-		statistics: PT.func.isRequired,
-	},
-
 	render: function() {
 		return	<div>
@@ -421,5 +463,5 @@
 
 						<h3>Statistics</h3>
-						<button type="button" className="btn btn-default btn-lg" onClick={this.props.statistics} >
+						<button type="button" className="btn btn-default btn-lg" onClick={function() {main.toStatistics(true);}} >
 							<span className="glyphicon glyphicon-cog" aria-hidden="true"> </span> 
 							View server log
@@ -431,6 +473,6 @@
 
 var Footer = React.createClass({
-	about: function(e) {
-		main.about();
+	toAbout: function(e) {
+		main.toAbout(true);
 		e.preventDefault();
 		e.stopPropagation();
@@ -441,5 +483,5 @@
 			<div className="container">
 				<div id="CLARIN_footer_left">
-						<a title="about" href="#" onClick={this.about}> 
+						<a title="about" href="about" onClick={this.toAbout}> 
 						<span className="glyphicon glyphicon-info-sign"></span>
 						<span>{VERSION}</span>
@@ -462,6 +504,54 @@
 });
 
+function endsWith(str, suffix) {
+    return str.indexOf(suffix, str.length - suffix.length) !== -1;
+}
+
+var routeFromLocation = function(com) {
+	var path = window.location.pathname.split('/');
+	if (path.length === 3) {
+		var p = path[2];
+		if (p === 'help') {
+			com.toHelp(false);
+		} else if (p === 'about') {
+			com.toAbout(false);
+		} else if (p === 'stats') {
+			com.toStatistics(false);
+		} else {
+			com.toAggregator(false);
+		}
+	} else {
+		com.toAggregator(false);
+	}
+};
+
 var main = React.render(<Main />,  document.getElementById('body'));
 React.render(<Footer />, document.getElementById('footer') );
 
+window.onpopstate = function(event) {
+	console.log("popped location: " + document.location + ", state: " + JSON.stringify(event.state));
+	routeFromLocation(main);
+};
+
+window.main = main;
+
 })();
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
